/* To check the position of the mouse cursor. */

#define WIN32_LEAN_AND_MEAN
#include <windows.h>




#define SHARED(X) X __attribute__((section(".BBHSMouseHookSharedData"),shared))

static HMODULE G_hmodule = NULL;
static HHOOK SHARED(G_hhook) = NULL;
static HWND SHARED(G_hwnd) = NULL;
static UINT SHARED(G_callback_msg);




static LRESULT CALLBACK
_BBHSMouseHook_Proc(int ncode, WPARAM wp, LPARAM lp)
{
	MOUSEHOOKSTRUCT* pmhs = (MOUSEHOOKSTRUCT*)lp;

	if ((ncode == HC_ACTION)
	    && (pmhs != NULL)
	    && (G_hwnd != NULL))
	{
		PostMessage(G_hwnd, G_callback_msg,
		            wp, MAKELONG(pmhs->pt.x, pmhs->pt.y));
	}

	return CallNextHookEx(G_hhook, ncode, wp, lp);
}




__declspec(dllexport) BOOL
BBHSMouseHook_Begin(HWND hwnd, UINT callback_msg)
{
	if (G_hmodule == NULL) return FALSE;
	if (G_hhook != NULL) return FALSE;

	G_hhook = SetWindowsHookEx(WH_MOUSE, _BBHSMouseHook_Proc, G_hmodule,0);
	if (G_hhook == NULL) return FALSE;

	G_hwnd = hwnd;
	G_callback_msg = callback_msg;
	return TRUE;
}




__declspec(dllexport) BOOL
BBHSMouseHook_End(void)
{
	BOOL result;

	if (G_hhook == NULL) return FALSE;

	result = UnhookWindowsHookEx(G_hhook);
	G_hhook = NULL;
	G_hwnd = NULL;
	/* G_callback_msg = ... */
	return result != 0;
}




BOOL WINAPI
DllMain(HINSTANCE dll_instance, DWORD reason, LPVOID reserved)
{
	if (reason == DLL_PROCESS_ATTACH) {
		G_hmodule = dll_instance;
		DisableThreadLibraryCalls(dll_instance);
	} else if (reason == DLL_PROCESS_DETACH) {
		BBHSMouseHook_End();
	}

	return TRUE;
}




/* __END__ */
